"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles = require("@material-ui/core/styles");

var _Drawer = _interopRequireDefault(require("@material-ui/core/Drawer"));

var _SwipeableDrawer = _interopRequireDefault(require("@material-ui/core/SwipeableDrawer"));

var _CssBaseline = _interopRequireDefault(require("@material-ui/core/CssBaseline"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Menu = _interopRequireDefault(require("@material-ui/icons/Menu"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _MoveToInbox = _interopRequireDefault(require("@material-ui/icons/MoveToInbox"));

var _Mail = _interopRequireDefault(require("@material-ui/icons/Mail"));

var _reactRouterDom = require("react-router-dom");

var _Context = _interopRequireDefault(require("base-shell/lib/providers/Config/Context"));

var _Context2 = _interopRequireDefault(require("../../providers/Menu/Context"));

var _reactIntl = require("react-intl");

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

var _this = void 0,
    _jsxFileName = "C:\\github\\os\\react-most-wanted\\packages\\material-ui-shell\\src\\containers\\Menu\\Menu.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var drawerWidth = 240;
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    root: {
      display: 'flex'
    },
    appBar: {
      transition: theme.transitions.create(['margin', 'width'], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      })
    },
    appBarShift: {
      width: "calc(100% - " + drawerWidth + "px)",
      marginLeft: drawerWidth,
      transition: theme.transitions.create(['margin', 'width'], {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.enteringScreen
      })
    },
    menuButton: {
      marginRight: theme.spacing(2)
    },
    hide: {
      display: 'none'
    },
    drawer: {
      width: drawerWidth,
      flexShrink: 0
    },
    drawerPaper: {
      width: drawerWidth
    },
    drawerHeader: _extends(_extends({
      display: 'flex',
      alignItems: 'center',
      padding: theme.spacing(0, 1)
    }, theme.mixins.toolbar), {}, {
      justifyContent: 'flex-end'
    }),
    content: {
      flexGrow: 1,
      padding: theme.spacing(3),
      transition: theme.transitions.create('margin', {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      }),
      marginLeft: -drawerWidth
    },
    contentShift: {
      transition: theme.transitions.create('margin', {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.enteringScreen
      }),
      marginLeft: 0
    }
  };
});

var Menu = function Menu() {
  var intl = (0, _reactIntl.useIntl)();
  var history = (0, _reactRouterDom.useHistory)();
  var match = (0, _reactRouterDom.useRouteMatch)();
  var classes = useStyles();
  var theme = (0, _styles.useTheme)();
  var isDesktop = (0, _useMediaQuery.default)('(min-width:600px)');

  var _useContext = (0, _react.useContext)(_Context2.default),
      isDesktopOpen = _useContext.isDesktopOpen,
      isMobileOpen = _useContext.isMobileOpen,
      isMini = _useContext.isMini,
      setDesktopOpen = _useContext.setDesktopOpen,
      setMobileOpen = _useContext.setMobileOpen;

  var _useContext2 = (0, _react.useContext)(_Context.default),
      appConfig = _useContext2.appConfig;

  var menuItems = appConfig.getMenuItems({
    intl,
    auth: appConfig.auth
  }).filter(function (item) {
    return item.visible !== false;
  });

  var handleDrawerClose = function handleDrawerClose() {
    if (isDesktop) {
      setDesktopOpen(false);
    } else {
      setMobileOpen(false);
    }
  };

  var index = match ? match.path : '/';

  var onIndexChange = function onIndexChange(event, index) {
    if (index !== undefined) {
      setMobileOpen(false);
    }

    if (index !== undefined && index !== Object(index)) {
      history.push(index);
    }
  };

  var getItem = function getItem(item, i) {
    //delete item.visible
    if (item !== undefined) {
      if (item.subheader !== undefined) {
        return /*#__PURE__*/_react.default.createElement("div", {
          key: i,
          inset: item.inset,
          style: item.style,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 138,
            columnNumber: 11
          }
        }, item.subheader);
      } else if (item.divider !== undefined) {
        return /*#__PURE__*/_react.default.createElement(_Divider.default, {
          key: i,
          inset: item.inset,
          style: item.style,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 143,
            columnNumber: 16
          }
        });
      } else {
        return /*#__PURE__*/_react.default.createElement(_ListItem.default, {
          button: true,
          selected: index && index === item.value,
          key: i,
          onClick: function onClick(e) {
            onIndexChange(e, item.value); // this.handleNestedItemsClick(item)

            if (item.onClick) {
              item.onClick();
            }
          },
          onMouseDown: function onMouseDown(e) {
            if (e.button === 1) {
              var win = window.open("" + item.value, '_blank');
              win.focus();
            }
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 146,
            columnNumber: 11
          }
        }, item.leftIcon && /*#__PURE__*/_react.default.createElement(_ListItemIcon.default, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 164,
            columnNumber: 31
          }
        }, item.leftIcon), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
          primary: item.primaryText,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 166,
            columnNumber: 25
          }
        }));
      }
    }

    return null;
  };

  return /*#__PURE__*/_react.default.createElement(_SwipeableDrawer.default, {
    className: classes.drawer,
    variant: isDesktop ? 'persistent' : 'temporary',
    anchor: "left",
    open: isDesktop ? isDesktopOpen : isMobileOpen,
    onClose: function onClose() {
      setMobileOpen(false);
    },
    onOpen: function onOpen() {
      setMobileOpen(true);
    },
    classes: {
      paper: classes.drawerPaper
    },
    ModalProps: {
      keepMounted: true // Better open performance on mobile.

    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 188,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.drawerHeader,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 206,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: handleDrawerClose,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 207,
      columnNumber: 9
    }
  }, theme.direction === 'ltr' ? /*#__PURE__*/_react.default.createElement(_ChevronLeft.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 209,
      columnNumber: 13
    }
  }) : /*#__PURE__*/_react.default.createElement(_ChevronRight.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 211,
      columnNumber: 13
    }
  }))), /*#__PURE__*/_react.default.createElement(_Divider.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 215,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react.default.createElement(_List.default, {
    value: index,
    onChange: onIndexChange,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 216,
      columnNumber: 7
    }
  }, menuItems.filter(function (item) {
    return item.visible !== false;
  }).map(function (item, i) {
    return getItem(item, i);
  })));
};

var _default = Menu;
exports.default = _default;
module.exports = exports.default;