"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles = require("@material-ui/core/styles");

var _Drawer = _interopRequireDefault(require("@material-ui/core/Drawer"));

var _CssBaseline = _interopRequireDefault(require("@material-ui/core/CssBaseline"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Menu = _interopRequireDefault(require("@material-ui/icons/Menu"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _MoveToInbox = _interopRequireDefault(require("@material-ui/icons/MoveToInbox"));

var _Mail = _interopRequireDefault(require("@material-ui/icons/Mail"));

var _reactIntl = require("react-intl");

var _Context = _interopRequireDefault(require("base-shell/lib/providers/Online/Context"));

var _Context2 = _interopRequireDefault(require("../../providers/Menu/Context"));

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

var _this = void 0,
    _jsxFileName = "C:\\github\\os\\react-most-wanted\\packages\\material-ui-shell\\src\\containers\\Page\\Page.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var drawerWidth = 240;
var offlineIndicatorHeight = 12;
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    root: {
      width: '100%',
      display: 'flex',
      flexDirection: 'column'
    },
    appBar: {
      transition: theme.transitions.create(['margin', 'width'], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      })
    },
    appBarShift: {
      width: "calc(100% - " + drawerWidth + "px)",
      marginLeft: drawerWidth,
      transition: theme.transitions.create(['margin', 'width'], {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.enteringScreen
      })
    },
    menuButton: {
      marginRight: theme.spacing(2)
    },
    hide: {
      display: 'none'
    },
    drawer: {
      width: drawerWidth,
      flexShrink: 0
    },
    drawerPaper: {
      width: drawerWidth
    },
    drawerHeader: _extends(_extends({
      display: 'flex',
      alignItems: 'center',
      padding: theme.spacing(0, 1)
    }, theme.mixins.toolbar), {}, {
      justifyContent: 'flex-end'
    }),
    offlineIndicator: {
      position: 'absolute',
      display: 'flex',
      alignItems: 'center',
      backgroundColor: theme.palette.secondary.main,
      justifyContent: 'center',
      right: 0,
      left: 0,
      height: offlineIndicatorHeight
    },
    content: {
      flexGrow: 1,
      //padding: theme.spacing(3),
      transition: theme.transitions.create('margin', {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      }),
      marginLeft: -drawerWidth
    },
    contentShift: {
      transition: theme.transitions.create('margin', {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.enteringScreen
      }),
      marginLeft: 0
    }
  };
});

var Page = function Page(_ref) {
  var children = _ref.children,
      pageTitle = _ref.pageTitle;
  var isOnline = (0, _react.useContext)(_Context.default);
  var isDesktop = (0, _useMediaQuery.default)('(min-width:600px)');

  var _useContext = (0, _react.useContext)(_Context2.default),
      isDesktopOpen = _useContext.isDesktopOpen,
      setDesktopOpen = _useContext.setDesktopOpen,
      setMobileOpen = _useContext.setMobileOpen;

  var intl = (0, _reactIntl.useIntl)();
  var headerTitle = '';

  if (typeof pageTitle === 'string' || pageTitle instanceof String) {
    headerTitle = pageTitle;
  }

  var classes = useStyles();
  var theme = (0, _styles.useTheme)();

  var handleDrawerOpen = function handleDrawerOpen() {
    if (isDesktop) {
      setDesktopOpen(true);
    } else {
      setMobileOpen(true);
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: classes.root,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 123,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react.default.createElement(_AppBar.default, {
    position: "fixed",
    className: (0, _clsx.default)(classes.appBar, {
      [classes.appBarShift]: isDesktop && isDesktopOpen
    }),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 124,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react.default.createElement(_Toolbar.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 130,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: handleDrawerOpen,
    edge: "start",
    className: (0, _clsx.default)(classes.menuButton, isDesktop && isDesktopOpen && classes.hide),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 131,
      columnNumber: 11
    }
  }, /*#__PURE__*/_react.default.createElement(_Menu.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 141,
      columnNumber: 13
    }
  })), /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "h6",
    noWrap: true,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 143,
      columnNumber: 11
    }
  }, headerTitle))), /*#__PURE__*/_react.default.createElement("div", {
    className: classes.drawerHeader,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 149,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react.default.createElement("main", {
    className: (0, _clsx.default)(classes.content, {
      [classes.contentShift]: isDesktopOpen
    }),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 151,
      columnNumber: 7
    }
  }, !isOnline && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 157,
      columnNumber: 11
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.offlineIndicator,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 158,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "caption",
    noWrap: true,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 159,
      columnNumber: 15
    }
  }, intl.formatMessage({
    id: 'offline',
    defaultMessage: 'Offline'
  }))), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      height: offlineIndicatorHeight
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 166,
      columnNumber: 13
    }
  })), children));
};

var _default = Page;
exports.default = _default;
module.exports = exports.default;